% This is simulation code provided to help with the development of
% IEEE 802.3dm.
%
% This code is provided for reference to allow independent evaluation
% of the accuracy and applicability of the simulation results shared in
% IEEE 802.3dm presentations by the author.
%
% Written by Ragnar Jonsson, affiliated with Marvell Technology, Inc.
% Version 1.1, January 7th, 2025
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
% DEALINGS IN THE SOFTWARE.
function out = Qformat(format_string)
  if(nargin < 1)
    format_string = 0;
  end

  switch(format_string(1))
    case 'q'
      ix=strfind(format_string,'.');
      i = eval(format_string(2:ix-1));
      b = eval(format_string(ix+1:end));
      st = 0.5^b;
      mx = 2^i - st;
      mn = -2^i;
      out = [mn st mx];
    case 'p'
      pam_levels = str2num(format_string(4:end));
      st = 2/(pam_levels-1);
      out = [-1 st 1];
    otherwise
      out = format_string;
    end
end
